import { ElementRef, OnInit } from '@angular/core';
import { AnimationService } from './animation.service';
import { AnimationBuilder } from '../builder';
import { AnimationOptions } from '../contracts';
import * as i0 from "@angular/core";
export declare class AnimatesDirective implements OnInit {
    private _elementRef;
    private _defaultOptions;
    private _initOptions;
    private _initMode;
    private _animationBuilder;
    private _started;
    set animates(options: AnimationOptions);
    set animatesOnInit(options: AnimationOptions);
    set animatesInitMode(mode: string);
    get animationBuilder(): AnimationBuilder;
    constructor(_elementRef: ElementRef, animationService: AnimationService);
    ngOnInit(): void;
    start(options?: AnimationOptions): Promise<void | HTMLElement>;
    hide(options?: AnimationOptions): Promise<void | HTMLElement>;
    show(options?: AnimationOptions): Promise<void | HTMLElement>;
    animate(options?: AnimationOptions): Promise<void | HTMLElement>;
    pause(): void;
    resume(): void;
    toggle(): void;
    stop(): void;
    startOrStop(options?: AnimationOptions): void;
    private setOptions;
    static ɵfac: i0.ɵɵFactoryDeclaration<AnimatesDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AnimatesDirective, "[animates]", ["animates"], { "animates": "animates"; "animatesOnInit": "animatesOnInit"; "animatesInitMode": "animatesInitMode"; }, {}, never>;
}
